// WL_AGENT.C

#include "WL_DEF.H"
#pragma hdrstop

/*
=============================================================================

						 LOCAL CONSTANTS

=============================================================================
*/

#define MAXMOUSETURN	10
#define STORY

#define MOVESCALE	150l
#define BACKMOVESCALE	100l
#define ANGLESCALE	20

#define SWITCHTILE      2
/*
=============================================================================

						 GLOBAL VARIABLES

=============================================================================
*/



//
// player state info
//
boolean		running;
long		thrustspeed;

unsigned	plux,pluy;	// player coordinates scaled to unsigned

int		anglefrac;
int		gotgatgun;	// JR

objtype		*LastAttacker;

/*
=============================================================================

						 LOCAL VARIABLES

=============================================================================
*/


void	T_Player (objtype *ob);
void	T_Attack (objtype *ob);
void    WarpPlayer (int facedir);

statetype s_player = {false,0,0,T_Player,NULL,NULL};
statetype s_attack = {false,0,0,T_Attack,NULL,NULL};


long	playerxmove,playerymove;

struct atkinf
{
	char	tics,attack,frame;		// attack is 1 for gun, 2 for knife
} attackinfo[7][14] =

{
{ {6,0,1},{6,2,2},{6,0,3},{6,-1,4} },
{ {6,0,1},{6,1,2},{6,0,3},{6,-1,4} },
{ {6,0,1},{6,1,2},{6,3,3},{6,-1,4} },
{ {6,0,1},{6,1,2},{6,4,3},{6,-1,4} },
{ {6,0,1},{6,1,2},{6,5,3},{6,-1,4} },
{ {6,0,1},{6,2,2},{6,-1,3} },
{ {6,0,1},{6,2,2},{6,-1,3} },
};


int	strafeangle[9] = {0,90,180,270,45,135,225,315,0};

void DrawKills (void); 
void DrawWeapon (void);
void GiveWeapon (int weapon);
void GiveAmmo (int ammo);
void GiveExtraAmmo1 (int extraammo1);
void GiveExtraAmmo2 (int extraammo2);
void GiveBackPack (void);
void GiveArmor(int points);

//===========================================================================

//----------

void Attack (void);
void Use (void);
void Search (objtype *ob);
void SelectWeapon (void);
void SelectItem (void);

//----------

boolean TryMove (objtype *ob);
void T_Player (objtype *ob);

void ClipMove (objtype *ob, long xmove, long ymove);

/*
=============================================================================

						CONTROL STUFF

=============================================================================
*/

#ifndef OPTIMIZED
/*
=========================
=
= CheckWeaponChange
=
= Keys 1-7 change weapons
=
= The old routine
= 
=========================
*/
void CheckWeaponChange (void)
{
  int i,buttons;
  if (!gamestate.ammo && !gamestate.extraammo1) // must use knife with no ammo
	 return;
  switch (LastScan)
  {
      case 2:
	   LastScan=0;
	   if(gamestate.bestweapon >= wp_knife && gamestate.weapon != wp_knife)
	   {
	   gamestate.nextweapon = gamestate.chosenweapon = wp_knife;
	   gamestate.changingweapon = true;
	   gamestate.goingdown = true;
	   }
	   break;
      case 3:
	   LastScan=0;
	   if(gamestate.bestweapon >= wp_pistol && gamestate.weapon != wp_pistol)
	   {
	   gamestate.nextweapon = gamestate.chosenweapon = wp_pistol;
	   gamestate.changingweapon = true;
	   gamestate.goingdown = true;
	   DrawAmmo();
	   }
	   break;
      case 4:
	   LastScan=0;
	   if(gamestate.bestweapon >= wp_machinegun && gamestate.weapon != wp_machinegun)
	   {
	   gamestate.nextweapon = gamestate.chosenweapon = wp_machinegun;
	   gamestate.changingweapon = true;
	   gamestate.goingdown = true;
	   DrawAmmo();
	   }
	   break;
      case 5:
	   LastScan=0;
	   if(gamestate.bestweapon >= wp_chaingun && gamestate.weapon != wp_chaingun)
	   {
	   gamestate.nextweapon = gamestate.chosenweapon = wp_chaingun;
	   gamestate.changingweapon = true;
	   gamestate.goingdown = true;
	   DrawExtraAmmo1();
	   }
	   break;
      case 6:
	   LastScan=0;
	   if(gamestate.bestweapon >= wp_stengun && gamestate.weapon != wp_stengun)
	   {
	   gamestate.nextweapon = gamestate.chosenweapon = wp_stengun;
	   gamestate.changingweapon = true;
	   gamestate.goingdown = true;
	   DrawExtraAmmo1();
	   }
	   break;
      case 7:
	   LastScan=0;
	   if(gamestate.bestweapon >= wp_axe && gamestate.weapon != wp_axe)
	   {
	   gamestate.nextweapon = gamestate.chosenweapon = wp_axe;
	   gamestate.changingweapon = true;
	   gamestate.goingdown = true;
	   }
	   break;
      case 8:
	   LastScan=0;
	   if(gamestate.bestweapon >= wp_lance)
	   {
	   gamestate.nextweapon = gamestate.chosenweapon = wp_lance;
	   gamestate.changingweapon = true;
	   gamestate.goingdown = true;
	   }
	   break;
  }

}
#else
/*
=========================
=
= CheckAttackAmmo 
= CheckWeaponChange
=
=
= The new routine
= 
=========================
*/

// Checks to make sure you have ammo for weapon 
// returns "true" if yes and "false" if no 
int ChkAtkAmmo (int weapon) 
{ 
  switch (weapon) 
  {    
    case wp_knife:
    case wp_axe:         //Weapons without ammo 
    case wp_lance:
            return 1; 

    case wp_pistol: 
    case wp_machinegun:
         if(gamestate.ammo > 0 ) 
                  return 1;    
         break;  

    case wp_chaingun: 
    case wp_stengun:
         if(gamestate.extraammo1 >0) 
                  return;
         break;

  } 
  return 0;
}

//==============================================

void CheckWeaponChange (void)
{
   int  i,kbuttons[7]={sc_1,sc_2,sc_3,sc_4,sc_5,sc_6,sc_7};
   for (i=0;i<NUMWEAPONS;i++)
	if ((Keyboard[kbuttons[i]]) && (i != gamestate.weapon))
	{

#ifdef BESTWEAPON
	 if (gamestate.bestweapon & (1<<i) && ChkAtkAmmo(i))
#else
	 if (ChkAtkAmmo(i) && i <= gamestate.bestweapon)
#endif
	 {


	    gamestate.changingweapon = true;
	    gamestate.goingdown = true;
	    gamestate.nextweapon = gamestate.chosenweapon = i;

	    DrawExtraAmmo1();
	    DrawAmmo();
	    return;
	 }
    }
}
#endif

/*
=======================
=
= ControlMovement
=
= Takes controlx,controly, and buttonstate[bt_strafe]
=
= Changes the player's angle and position
=
= There is an angle hack because when going 70 fps, the roundoff becomes
= significant
=
=======================
*/

void ControlMovement (objtype *ob)
{
	long	oldx,oldy;
	int		angle,maxxmove;
	int		angleunits;
	long	speed;

	thrustspeed = 0;

	oldx = player->x;
	oldy = player->y;

//
// side to side move
//
	if (buttonstate[bt_strafe])
	{
	//
	// strafing
	//
	//
		if (controlx > 0)
		{
			angle = ob->angle - ANGLES/4;
			if (angle < 0)
				angle += ANGLES;
			Thrust (angle,controlx*MOVESCALE);	// move to left
		}
		else if (controlx < 0)
		{
			angle = ob->angle + ANGLES/4;
			if (angle >= ANGLES)
				angle -= ANGLES;
			Thrust (angle,-controlx*MOVESCALE);	// move to right
		}
	}
	else
	{
	//
	// not strafing
	//
		anglefrac += controlx;
		angleunits = anglefrac/ANGLESCALE;
		anglefrac -= angleunits*ANGLESCALE;
		ob->angle -= angleunits;

		if (ob->angle >= ANGLES)
			ob->angle -= ANGLES;
		if (ob->angle < 0)
			ob->angle += ANGLES;

	}

//
// forward/backwards move
//
	if (controly < 0)
	{
		Thrust (ob->angle,-controly*MOVESCALE);	// move forwards
	}
	else if (controly > 0)
	{
		angle = ob->angle + ANGLES/2;
		if (angle >= ANGLES)
			angle -= ANGLES;
		Thrust (angle,controly*BACKMOVESCALE);		// move backwards
	}

	if (gamestate.victoryflag)		// watching the BJ actor
		return;

//
// calculate total move
//
	playerxmove = player->x - oldx;
	playerymove = player->y - oldy;
}

/*
=============================================================================

					STATUS WINDOW STUFF

=============================================================================
*/


/*
==================
=
= StatusDrawPic
=
==================
*/

void StatusDrawPic (unsigned x, unsigned y, unsigned picnum)
{
	unsigned	temp;

	temp = bufferofs;
	bufferofs = 0;

	bufferofs = PAGE1START+(200-STATUSLINES)*SCREENWIDTH;
	LatchDrawPic (x,y,picnum);
	bufferofs = PAGE2START+(200-STATUSLINES)*SCREENWIDTH;
	LatchDrawPic (x,y,picnum);
	bufferofs = PAGE3START+(200-STATUSLINES)*SCREENWIDTH;
	LatchDrawPic (x,y,picnum);

	bufferofs = temp;
}

/*
==================
=
= DrawFace
=
==================
*/

void DrawFace (void)
{
	if (gamestate.health)
	{
		if(godmode)
		    StatusDrawPic (17,4,GODMODEFACE1PIC+gamestate.faceframe);
		else		
                    StatusDrawPic (17,4,FACE1APIC+3*((100-gamestate.health)/16)+gamestate.faceframe);
	}
	else
	{
#ifndef SPEAR
	 if (LastAttacker->obclass == needleobj)
	   StatusDrawPic (17,4,MUTANTBJPIC);
	 else
#endif
	   StatusDrawPic (17,4,FACE8APIC);
	}
}

/*
===================================
=
= UpdateFace 
=
= Calls draw face if time to change
=
===================================
*/

#define FACETICS	70

int	facecount;

void	UpdateFace (void)
{
        DrawKills(); 
	DrawPlayerWeapon ();

	if (SD_SoundPlaying() == GETGATLINGSND)
	  return;

	facecount += tics;
	if (facecount > US_RndT())
	{
		gamestate.faceframe = (US_RndT()>>6);
		if (gamestate.faceframe==3)
			gamestate.faceframe = 1;

		facecount = 0;
		DrawFace ();
	}
}

/*
======================================
=
= LatchNumber
=
= right justifies and pads with blanks
=
======================================
*/

void	LatchNumber (int x, int y, int width, long number)
{
	unsigned	length,c;
	char	str[20];

	ltoa (number,str,10);

	length = strlen (str);

	while (length<width)
	{
		StatusDrawPic (x,y,N_BLANKPIC);
		x++;
		width--;
	}

	c= length <= width ? 0 : length-width;

	while (c<length)
	{
		StatusDrawPic (x,y,str[c]-'0'+ N_0PIC);
		x++;
		c++;
	}
}

/*
===============
=
= DrawHealth
= Correct
=
===============
*/

void	DrawHealth (void)
{
	LatchNumber (22,23,3,gamestate.health);
}


/*
===============
=
= TakeDamage
=
===============
*/

void	TakeDamage (int points,objtype *attacker)
{
	LastAttacker = attacker;

	if (gamestate.victoryflag)
		return;
	if (gamestate.difficulty==gd_baby || gamestate.difficulty==gd_nightmare)
	  points>>=2;

	if (!godmode)
	{
	   if(gamestate.armor)
	   {
	      if((gamestate.health -= points / 3) >= 0)
	      {
		  gamestate.health -= ((int)points / 3);
		  if(gamestate.health > 115)
		     gamestate.health = 115;
	      }
	      gamestate.armor -= points / 2 + 2;
	   }
	   else
	   {
	      gamestate.health -= points;
	   }
	}
	if (gamestate.armor <= 0)
	    gamestate.armor = 0;

	if (gamestate.health<=0)
	{
		gamestate.health = 0;
		playstate = ex_died;
		killerobj = attacker;
	}

	if (!godmode)

	StartDamageFlash (points);

	gotgatgun=0;

	DrawHealth ();
	DrawFace ();

	//
	// MAKE BJ'S EYES BUG IF MAJOR DAMAGE!
	//
	#ifdef SPEAR
	if (points > 30 && gamestate.health!=0 && !godmode)
	{
		StatusDrawPic (17,4,BJOUCHPIC);
		facecount = 0;
	}
	#endif

}


/*
===============
=
= HealSelf
=
===============
*/

void	HealSelf (int points)
{
	gamestate.health += points;
	if (gamestate.health>100)
		gamestate.health = 100;

	DrawHealth ();
	gotgatgun = 0;	// JR
	DrawFace ();
}


//===========================================================================


/*
===============
=
= DrawLevel
= Correct
=
===============
*/

void	DrawLevel (void)
{
#ifdef SPEAR
	if (gamestate.mapon == 20)
		LatchNumber (2,5,3,18);
	else
#endif
	LatchNumber (3,5,3,gamestate.mapon+1);
}

//===========================================================================


/*
===============
=
= DrawLives
= Correct
=
===============
*/

void	DrawLives (void)
{
	LatchNumber (27,23,1,gamestate.lives);
}


/*
===============
=
= GiveExtraMan
=
===============
*/

void	GiveExtraMan (void)
{
	if (gamestate.lives<9)
		gamestate.lives++;
	DrawLives ();
	SD_PlaySound (BONUS1UPSND);
}

//===========================================================================

/*
===============
=
= DrawScore
= Correct
=
===============
*/

void	DrawScore (void)
{
	LatchNumber (8,23,7,gamestate.score);
}

/*
===============
=
= GivePoints
=
===============
*/

void	GivePoints (long points)
{
	gamestate.score += points;
	while (gamestate.score >= gamestate.nextextra)
	{
		gamestate.nextextra += EXTRAPOINTS;
		GiveExtraMan ();
	}
	DrawScore ();
}

//===========================================================================

/*
==================
=
= DrawWeapon
=
==================

//void DrawWeapon (void)
//{
//	StatusDrawPic (32,8,KNIFEPIC+gamestate.weapon);
//}

=======
=
= Armor
=
=======
*/

void GiveArmor(int points)
{
     gamestate.armor += points;
     if (gamestate.armor > 100)
	 gamestate.health = 100;
}
/*
==================
=
= DrawKeys
= Correct
=
==================
*/

void DrawKeys (void)
{
	if (gamestate.keys & 1)
		StatusDrawPic (30,5,GOLDKEYPIC);
	else
		StatusDrawPic (30,5,NOKEYPIC);

	if (gamestate.keys & 2)
		StatusDrawPic (30,22,SILVERKEYPIC);
	else
		StatusDrawPic (30,22,NOKEYPIC);

	if (gamestate.keys & 4)
		StatusDrawPic (31,5,MACHINEGUNPIC);
	else
		StatusDrawPic (31,5,NOKEYPIC);

	if (gamestate.keys & 8)
		StatusDrawPic (31,22,GATLINGGUNPIC);
	else
		StatusDrawPic (31,22,NOKEYPIC);
}



/*
==================
=
= GiveWeapon
=
==================
*/

void GiveWeapon (int weapon)
{
		if (gamestate.bestweapon<weapon)
			gamestate.bestweapon = gamestate.weapon
			= gamestate.chosenweapon = weapon;

//              DrawWeapon ();
}

//===========================================================================
/* 
============ 
= 
= DrawKills 
= Correct
= 
============ 
*/ 

void DrawKills (void) 
{ 
     LatchNumber(3,22,3,gamestate.killcount); 
     // x,y = coordinates to draw it on the statusbar 
} 

/*
===============
=
= DrawItem
= Correct
=
===============
*/

void DrawItem(void)
{
     if(medikit>0)
        StatusDrawPic(36,22,NEWPIC1);

else if(crowbar)
        StatusDrawPic(36,22,NEWPIC2);
else
        StatusDrawPic(36,22,NEWPIC3);
}
/*
===============
=
= DrawAmmo
= Correct
=
===============
*/

void	DrawAmmo (void)
{
	LatchNumber (36,5,3,gamestate.ammo);
}
void    DrawExtraAmmo1 (void)
{
	LatchNumber (36,5,3,gamestate.extraammo1);  // can be changed to 33,16,3,gamestate.extraammo1
}
/*
void    DrawExtraAmmo2 (void)
{
	LatchNumber (36,5,3,gamestate.extraammo2);
}
*/
/*
==========
=
= GiveAmmo
=
==========
*/

void	GiveAmmo (int ammo)
{
	if (!gamestate.ammo)				// knife was out
	{
		if (!gamestate.attackframe)
		{
			gamestate.weapon = gamestate.chosenweapon;
		//	DrawWeapon ();
		}
	}
	gamestate.ammo += ammo;
	if (gamestate.ammo > gamestate.ammomax)
		gamestate.ammo = gamestate.ammomax;
	if (gamestate.chosenweapon <= wp_machinegun)
	DrawAmmo ();
}

/*
===============
=
= GiveExtraAmmo
=
===============
*/

void	GiveExtraAmmo1 (int extraammo1)
{
	if (!gamestate.extraammo1)	                 	// knife was out
	{
		if (!gamestate.attackframe)
		{
			gamestate.weapon = gamestate.chosenweapon;
		//	DrawWeapon ();
		}
	}
	gamestate.extraammo1 += extraammo1;
	if (gamestate.extraammo1 > gamestate.extraammomax1)
		gamestate.extraammo1 = gamestate.extraammomax1;
	if (gamestate.chosenweapon >= wp_chaingun)
	DrawExtraAmmo1 ();
}

/*
==============================
=
= GiveBackPack (by Deathshead)
=
==============================
*/

void GiveBackPack (void)
{
     if (gamestate.ammomax < 99)
     {
	 gamestate.ammomax += AMMOMAX;
	 DrawAmmo();
     }
     else
     {
	 gamestate.ammomax = 99;
	 DrawAmmo ();
     }

     if (gamestate.extraammomax1 < 250)
     {
	 gamestate.extraammomax1 += EXTRAAMMOMAX1;
	 DrawExtraAmmo1();
     }
     else
     {
	 gamestate.extraammomax1 = 250;
	 DrawExtraAmmo1 ();
     }
}

//===========================================================================

/*
=========
=
= GiveKey
=
=========
*/

void GiveKey (int key)
{
	gamestate.keys |= (1<<key);
	DrawKeys ();
}



/*
=============================================================================

							MOVEMENT

=============================================================================
*/


/*
==========
=
= GetBonus
=
==========
*/
void GetBonus (statobj_t *check)
{
	switch (check->itemnumber)
	{

//--- Other:

	case    bo_backpack:
		 SD_PlaySound (BONUS2SND);
		 GiveBackPack ();
		 GetMessage("Found a backpack.");
		break;

	case    bo_uniform:
 		 if(gamestate.uniform == 1)
		        return;

		 SD_PlaySound (BONUS2SND);
                 gamestate.uniform = 1;
		 GetMessage("Found a disguise.");
		break;

//--- Keys:

	case	bo_key1:
	case	bo_key2:
	case	bo_key3:
	case	bo_key4:
		GiveKey (check->itemnumber - bo_key1);
		switch (check->itemnumber)
		{
		 case bo_key1:
		      GetMessage("Found the Gold key.");   break;
		 case bo_key2:
		      GetMessage("Found the Keycard.");    break;
		 case bo_key3:
		      GetMessage("Found the Bronze key."); break;
		 case bo_key4:
		      GetMessage("Found the Rusty key.");  break;
		}
		SD_PlaySound (GETKEYSND);
		break;

//--- Treasure:

	case	bo_cross:
		 SD_PlaySound (BONUS1SND);
		 GivePoints (100);
		 gamestate.treasurecount++;
		 GetMessage("Found some gold.");
		break;

	case	bo_chalice:
		 SD_PlaySound (BONUS2SND);
		 GivePoints (500);
		 gamestate.treasurecount++;
	  	 GetMessage("Found a Gold bar.");
		break;

	case	bo_bible:
		 SD_PlaySound (BONUS3SND);
		 GivePoints (1000);
		 gamestate.treasurecount++;
		 GetMessage("Found a chest full of jewels.");
		break;

	case	bo_crown:
		 SD_PlaySound (BONUS4SND);
		 GivePoints (2500);
		 gamestate.treasurecount++;
		 GetMessage("Found a crown.");
		break;

	case    bo_gem:
		 SD_PlaySound (BONUS1SND);
		 GivePoints (5000);
		 gamestate.treasurecount++;
		 GetMessage("Found a large diamond.");
		break;

//--- Ammunition:

	case	bo_clip:
		if (gamestate.ammo == gamestate.ammomax)
				 return;
                 
		 SD_PlaySound (GETAMMOSND);
		 GiveAmmo (8);
		 GetMessage("Picked up a fresh clip.");
		break;

	case	bo_clip2:
		if (gamestate.ammo == gamestate.ammomax)
				 return;

		 SD_PlaySound (GETAMMOSND);
		 GiveAmmo (4);
		 GetMessage("Picked up a used clip.");
		break;


	case	bo_25clip:
                if (gamestate.ammo == gamestate.ammomax)
                                 return;
           
                 SD_PlaySound(GETAMMOBOXSND);
                 GiveAmmo(25);
                 GetMessage("Found a box of ammunition.");
       		break;


	case    bo_pistol:
		 SD_PlaySound (GETAMMOSND);
		 GiveWeapon (wp_pistol);
		 GiveAmmo (4);
		 GetMessage("Found a luger.");
		break;

	case	bo_machinegun:
		 SD_PlaySound (GETMACHINESND);
		 GiveWeapon (wp_machinegun);
		 GiveAmmo (6);
		 GetMessage("Found a machinegun.");
		break;

	case	bo_chaingun:
		 SD_PlaySound (GETGATLINGSND);
		 GiveWeapon (wp_chaingun);
		 GiveExtraAmmo1 (8);
		 GetMessage("Found a MMg-prototype 01.");

		 StatusDrawPic (17,4,GOTGATLINGPIC);
		 facecount = 0;
		 gotgatgun = 1;
		break;



	case    bo_ammo2:
		if (gamestate.extraammo1 == gamestate.extraammomax1)
				       return;

		 SD_PlaySound (BONUS3SND);
		 GiveExtraAmmo1 (8);
		 GetMessage("Found some MMg ammo.");
		break;

	case    bo_ammo2box:
		if (gamestate.extraammo1 == gamestate.extraammomax1)
				       return;

		 SD_PlaySound (GETAMMOBOXSND);
		 GiveExtraAmmo1 (25);
		 GetMessage("Found a box full of MMg ammo.");
		break;

	case    bo_mmg2:
		 SD_PlaySound (MLAUNCHSND);
		 GiveWeapon (wp_stengun);
		 GiveExtraAmmo1 (12);
		 GetMessage("Found a MMg-prototype 02.");

		 StatusDrawPic (17,4,GOTGATLINGPIC);
		 facecount = 0;
		 gotgatgun = 1;
		break;

//--- Health:

	case	bo_fullheal:
		 SD_PlaySound (BONUS1UPSND);
		 HealSelf (99);
		 GiveAmmo (25);
		 GiveExtraAmmo1 (25);
		 GiveExtraMan ();
		 gamestate.treasurecount++;
		 GetMessage("Found an extra life.");

		 StatusDrawPic (17,4,BJHAPPYPIC);
		 facecount = 0;
		break;

	case	bo_firstaid:
                if(gamestate.health == 100)
                       return;
                 
                 SD_PlaySound(HEALTH2SND);
                 HealSelf(25);
                 GetMessage("First aid used...");
        	break;


	case	bo_food:
		if (gamestate.health == 100)
			return;
                
		 SD_PlaySound (HEALTH1SND);
		 HealSelf (10);
		 GetMessage("Ate some food.");
		break;

	case	bo_alpo:
        #ifndef CONTEST
		if (gamestate.health == 100)
			return;

		 SD_PlaySound (HEALTH1SND);
                 HealSelf (5);
		   
                 GetMessage("Ate some dogfood.");
        #else
                SD_PlaySound(EXPLOSND);
                TakeDamage(200,NULL);
        #endif
                break;

	case	bo_gibs:
		if (gamestate.health >10)
			return;

		SD_PlaySound (SLURPIESND);
		HealSelf (1);
		break;

	case    bo_poison:
		if (godmode)
		return;

		SD_PlaySound (GODENDSND);
		HealSelf(-20);
		break;

	case    bo_glass:
                 if(medikit > 4) //only four medikits
                     return;
                
		 medikit++;
                                  
		 SD_PlaySound(BONUS1SND);
                 DrawItem();
                 GetMessage("Found a portable medikit.");  
		break; 

        case    bo_fire:
                     
                break;

//--- Artefact:

	case    bo_berserk:
                 StatusDrawPic (17,4,BJEVILPIC);
		 SD_PlaySound(GODSND);
		 GiveWeapon(wp_knife);
                 facecount = 0;

		 berserk = 1;
		 gamestate.berserk = true;
		 gamestate.berserkcount++;
                 gamestate.finaltime = 30*70; //Set TimerDisplay: 30sec
		break;

	case    bo_godmode:
		 SD_PlaySound (GODSND);
		 godmode = 1;
		 gamestate.godmode = true;
		 gamestate.godmodecount++;
                 gamestate.finaltime = 30*70; //Set TimerDisplay: 30sec
		break;

	case	bo_spear:
		 StatusDrawPic (17,4,BJHAPPYPIC);
		 facecount = 0;

		 spearflag = true;
		 spearx = player->x;
		 speary = player->y;
		 spearangle = player->angle;
		 playstate = ex_completed;
	}

	StartBonusFlash ();
	check->shapenum = -1;			// remove from list
	check->flags &= ~FL_BONUS;
}


/*
=================================
=
= TryMove
=
= returns true if move ok
= debug: use pointers to optimize
=
=================================
*/

boolean TryMove (objtype *ob)
{
	int		xl,yl,xh,yh,x,y;
	objtype		*check;
	long		deltax,deltay;

	xl = (ob->x-PLAYERSIZE) >>TILESHIFT;
	yl = (ob->y-PLAYERSIZE) >>TILESHIFT;

	xh = (ob->x+PLAYERSIZE) >>TILESHIFT;
	yh = (ob->y+PLAYERSIZE) >>TILESHIFT;

//
// check for solid walls
//
	for (y=yl;y<=yh;y++)
		for (x=xl;x<=xh;x++)
		{
			check = actorat[x][y];
			if (check && check<objlist)
				return false;
		}

//
// check for actors
//
	if (yl>0)
		yl--;
	if (yh<MAPSIZE-1)
		yh++;
	if (xl>0)
		xl--;
	if (xh<MAPSIZE-1)
		xh++;

	for (y=yl;y<=yh;y++)
		for (x=xl;x<=xh;x++)
		{
			check = actorat[x][y];
			if (check > objlist
			&& (check->flags & FL_SHOOTABLE) )
			{
				deltax = ob->x - check->x;
				if (deltax < -MINACTORDIST || deltax > MINACTORDIST)
					continue;
				deltay = ob->y - check->y;
				if (deltay < -MINACTORDIST || deltay > MINACTORDIST)
					continue;

				return false;
			}
		}

	return true;
}


/*
==========
=
= ClipMove
=
==========
*/

void ClipMove (objtype *ob, long xmove, long ymove)
{
	long	basex,basey;

	basex = ob->x;
	basey = ob->y;

	ob->x = basex+xmove;
	ob->y = basey+ymove;
	if (TryMove (ob))
		return;

	if (noclip && ob->x > 2*TILEGLOBAL && ob->y > 2*TILEGLOBAL &&
	ob->x < (((long)(mapwidth-1))<<TILESHIFT)
	&& ob->y < (((long)(mapheight-1))<<TILESHIFT) )
		return;		// walk through walls

	#ifndef NEWSOD
	if (!SD_SoundPlaying())
		SD_PlaySound (HITWALLSND);
	#endif

	ob->x = basex+xmove;
	ob->y = basey;
	if (TryMove (ob))
		return;

	ob->x = basex;
	ob->y = basey+ymove;
	if (TryMove (ob))
		return;

	ob->x = basex;
	ob->y = basey;
}

//==========================================================================

/*
=============
=
= VictoryTile
=
=============
*/

void VictoryTile (void)
{
	gamestate.victoryflag = true;
}


/*
=========
=
= Thrust
=
=========
*/

void Thrust (int angle, long speed)
{
        int doc = false;
	long xmove,ymove;
	long	slowmax;
	unsigned	offset;

	if (gamestate.bobdir != 2)
	   {gamestate.bobber++;}
	if (gamestate.bobdir == 2)
	   {gamestate.bobber--;}
	if (gamestate.bobber == 10)
	   {gamestate.bobdir = 2;}
	if (gamestate.bobber == 0)
	   {gamestate.bobdir = 1;}
	if (gamestate.bobdir2 != 2)
	   {gamestate.bobber2++;}
	if (gamestate.bobdir2 == 2)
	   {gamestate.bobber2--;}
	if (gamestate.bobber2 == 20)
	   {gamestate.bobdir2 = 2;}
	if (gamestate.bobber2 == 0)
	   {gamestate.bobdir2 = 1;}

	//
	// ZERO FUNNY COUNTER IF MOVED!
	//
	#ifdef SPEAR
	if (speed)
		funnyticount = 0;
	#endif

	thrustspeed += speed;
//
// moving bounds speed
//
	if (speed >= MINDIST*2)
		speed = MINDIST*2-1;

	xmove = FixedByFrac(speed,costable[angle]);
	ymove = -FixedByFrac(speed,sintable[angle]);

	ClipMove(player,xmove,ymove);

	player->tilex = player->x >> TILESHIFT;		// scale to tile values
	player->tiley = player->y >> TILESHIFT;

	offset = farmapylookup[player->tiley]+player->tilex;
	player->areanumber = *(mapsegs[0] + offset) -AREATILE;


//
// Special objects:
//

        //
        //Endgame - object
	//
        if (*(mapsegs[1] + offset) == EXITTILE)
	{ 

          switch(gamestate.mapon)
          {
#ifndef CONTEST
	      case 0:	
	         if(!flipper)
	         {
	            GetMessage("Press Space to enter the truck");
	            flipper=true;
	         }             

	      break;
#endif 
              case 1:
                  if(bombs<4) 
                     GetMessage("Warning, not all bombs defused...");
              break;     
       

              case 2:
                  if(!doc)
                  {  
                     doc = true;
                     GetMessage("Press space to browse through files");
                  }
              break;
          
    

	      default:

	       SD_PlaySound(GODSND);
	       playstate = ex_completed;
	      break;
	  }
	}
        //
        //Teleportation (within level)
        //   
	if (*(mapsegs[1] + offset) == WARPEASTTILE)
	    WarpPlayer(EAST);
	if (*(mapsegs[1] + offset) == WARPWESTTILE)
	    WarpPlayer(WEST);


        //
        // Teleportation (between levels)
        //
        if (*(mapsegs[1] + offset) == 390) // This warps to level 2       
        {
            gamestate.mapon = 2;
            playstate = ex_warped;
        }     
     

#ifdef CONTEST
       //Special event

      if (*(mapsegs[1] + offset) == 399)     
      {
       if(!doc)
       {
        switch(gamestate.mapon)
        {         
          case 1: 
           if(deact==true){} 
           else
           {
            if(!active)
            { 
             active = true;
             doc = true;
	     gamestate.finaltime = 70l*70; //Set TimerDisplay: 3min
	     GetMessage("2 minutes time to defuse the bombs");
            }
           }
          break;
        
          case 2: 
           if(!flipper) 
           {
              flipper = true;
	      GetMessage("Search for the documents...");
           }
           else{}
          break;
        }
       }
      }
      
#endif
}


/*
=============================================================================

								ACTIONS

=============================================================================
*/


/*
==========
=
= Cmd_Fire
=
==========
*/

void Cmd_Fire (void)
{
	if(gamestate.changingweapon == true)
		   return;
	buttonheld[bt_attack] = true;

	gamestate.weaponframe = 0;

	player->state = &s_attack;

	gamestate.attackframe = 0;
	gamestate.attackcount =
		attackinfo[gamestate.weapon][gamestate.attackframe].tics;
	gamestate.weaponframe =
		attackinfo[gamestate.weapon][gamestate.attackframe].frame;
}

//===========================================================================
/*
==================
=
= DoorOpen && DoorClose
=
==================
*/

void OpenDoor2()
{

    int		area1,area2;
    unsigned	far	*map;
    statobj_t   *statptr;

    map = mapsegs[0];

     if(statptr->shapenum == SPR_METAL1)
     {
	area1 =	*(map+1);
	area2 =	*(map-1);
     }
else if(statptr->shapenum == SPR_METAL3)
     {
	area1 =	*(map-mapwidth);
	area2 =	*(map+mapwidth);
     }

   area1 -= AREATILE;
   area2 -= AREATILE;
   areaconnect[area1][area2]++;
   areaconnect[area2][area1]++;
   ConnectAreas ();
}

void CloseDoor2()
{

   int		area1,area2;
   unsigned	far	*map;
   statobj_t    *statptr;

   map = mapsegs[0];

     if(statptr->shapenum == SPR_METAL2)
     {
	area1 =	*(map+1);
	area2 =	*(map-1);
     }
else if(statptr->shapenum == SPR_METAL4)
     {
	area1 =	*(map-mapwidth);
	area2 =	*(map+mapwidth);
     }

   area1 -= AREATILE;
   area2 -= AREATILE;
   areaconnect[area1][area2]--;
   areaconnect[area2][area1]--;

   ConnectAreas ();
}

/*
=========
=
= Cmd_Use
=
=========
*/

void Cmd_Use (void)
{
	objtype 	*check;
	int		checkx,checky,tilex,tiley,doornum,dir,paper=0;
	boolean		elevatorok;
	statobj_t       *statptr; 

//
// find which cardinal direction the player is facing
//
	if (player->angle < ANGLES/8 || player->angle > 7*ANGLES/8)
	{
		checkx = player->tilex + 1;
		checky = player->tiley;
		dir = di_east;
		elevatorok = true;
	}
	else if (player->angle < 3*ANGLES/8)
	{
		checkx = player->tilex;
		checky = player->tiley-1;
		dir = di_north;
		elevatorok = false;
	}
	else if (player->angle < 5*ANGLES/8)
	{
		checkx = player->tilex - 1;
		checky = player->tiley;
		dir = di_west;
		elevatorok = true;
	}
	else
	{
		checkx = player->tilex;
		checky = player->tiley + 1;
		dir = di_south;
		elevatorok = false;
	}

	doornum = tilemap[checkx][checky];
	if (*(mapsegs[1]+farmapylookup[checky]+checkx) == PUSHABLETILE)
	{
	//
	// pushable wall
	//

		PushWall (checkx,checky,dir);
		return;
	}
	if (!buttonheld[bt_use] && doornum == ELEVATORTILE && elevatorok)
	{
	//
	// use elevator
	//
		buttonheld[bt_use] = true;

 		gamestate.finaltime = 0;
                gamestate.godmodecount = 0;
                gamestate.berserkcount = 0;
                  
		if(gamestate.mapon==1 && active==true)
		{
		    if(gamestate.score < 1000)
		       gamestate.score = 0;
		    else gamestate.score = gamestate.score-1000;
		}

		tilemap[checkx][checky]++;		// flip switch
		if (*(mapsegs[0]+farmapylookup[player->tiley]+player->tilex) == ALTELEVATORTILE)
			playstate = ex_secretlevel;
		else
			playstate = ex_completed;
		SD_PlaySound (LEVELDONESND);
		SD_WaitSoundDone();
	}
/*
	if(!buttonheld[bt_use] && doornum >= 2)
        { 
           buttonheld[bt_use] = true; 
           if(doornum >= 2 && doornum <= 3) 
           { 
              switch(doornum)   // Flip the switch 
              { 
                  case 2: 
                        tilemap[checkx][checky]++; 
                        SD_PlaySound (LEVELDONESND); 
                        break; 
                  case 3: 
                        tilemap[checkx][checky]--; 
                        SD_PlaySound (LEVELDONESND); 
                        break; 
               } 
               switch(MAPSPOT(checkx,checky,1))  // activate/deactivate item 
               { 
                   case 404: 
                          fwall1 ^=1; // east switch 
                          break; 
                   case 405: 
                          fwall2 ^= 1; // north switch 
                          break; 
                   case 406: 
                          fwall3 ^= 1; // west switch 
                          break; 
                   case 407: 
                          fwall4 ^= 1; // south switch 
                          break; 

               } 
            } 
         } 

*/
//
// Special doors switch
//

	// Switch object ON
	for(statptr = &statobjlist[0]; statptr != laststatobj; statptr++)
	{
	   if(statptr->tilex == checkx && statptr->tiley == checky &&
	      statptr->shapenum == SPR_STAT_41 && !buttonheld[bt_use])
	   {
	      buttonheld[bt_use] = true;
	      statptr->shapenum = SPR_DEMO;

	      flipper = true;
	      SD_PlaySound(OPENDOORSND);
	   }
	}
	// Switch object OFF
	for(statptr = &statobjlist[0]; statptr != laststatobj; statptr++)
	{
	   if(statptr->tilex == checkx && statptr->tiley == checky &&
	      statptr->shapenum == SPR_DEMO && !buttonheld[bt_use])
	   {
	      buttonheld[bt_use] = true;
	      statptr->shapenum = SPR_STAT_41;

	      flipper = false;

	      SD_PlaySound(CLOSEDOORSND);
	   }
#ifdef STORY
            if(statptr->tilex == checkx && statptr->tiley == checky &&
	       statptr->shapenum == SPR_OBJ15 && !buttonheld[bt_use])
	       {
	           buttonheld[bt_use] = true;
		   GetMessage("Press F6 to view files...");
		   story1 = true;
	       }
#endif        

#ifdef CONTEST
            if(statptr->tilex == checkx && statptr->tiley == checky &&
	       statptr->shapenum == SPR_OBJ45 && !buttonheld[bt_use])
	       {
	           buttonheld[bt_use] = true;
                   statptr->shapenum = SPR_DEATHCAM;

		   SD_PlaySound(BONUS1UPSND);
		   bombs = bombs+1;
                   switch(bombs)
                   {
		       case 1: GetMessage("Bombs defused 1/4"); break;
		       case 2: GetMessage("Bombs defused 2/4"); break;
		       case 3: GetMessage("Bombs defused 3/4"); break;
		       case 4: GetMessage("All bombs are now defused."); deact=true; break;
                   }
                   if(bombs >3) 
                      gamestate.finaltime=0;
	       }
#endif  
	}


// Truck
if(!buttonheld[bt_use]&&doornum == 63 && gamestate.mapon == 0)
{
   buttonheld[bt_use] = true; 
   playstate = ex_completed;
}

//North/South

for(statptr = &statobjlist[0]; statptr != laststatobj; statptr++)
{
    if(statptr->shapenum == SPR_METAL1 && flipper)
    {
       statptr->shapenum = SPR_METAL3;
       OpenDoor2();
       (unsigned)actorat[statptr->tilex][statptr->tiley] = 0; // open door
    }

    else if(statptr->shapenum == SPR_METAL3 && !flipper)
    {
	statptr->shapenum = SPR_METAL1;
        CloseDoor2();
	(unsigned)actorat[statptr->tilex][statptr->tiley] = 1; // close door
    }
}

//East/West

for(statptr = &statobjlist[0]; statptr != laststatobj; statptr++)
{
    if(statptr->shapenum == SPR_METAL2 && flipper)
    {
       statptr->shapenum = SPR_METAL4;
       OpenDoor2();
       (unsigned)actorat[statptr->tilex][statptr->tiley] = 0; // open door
    }

    else if(statptr->shapenum == SPR_METAL4 && !flipper)
    {
	statptr->shapenum = SPR_METAL2;
        CloseDoor2();
	(unsigned)actorat[statptr->tilex][statptr->tiley] = 1; // close door
    }
}

	//
	// Special switch
	//
#ifndef CONTEST
	if(!buttonheld[bt_use]&&doornum>=SWITCHTILE &&doornum<=SWITCHTILE+1 )
	{

            buttonheld[bt_use] = true; 
            if(doornum>=SWITCHTILE &&doornum<=SWITCHTILE+1 ) 
            { 

               switch(doornum)   // Flip the switch 
               { 
                   case SWITCHTILE: 
                        tilemap[checkx][checky]++; 
                        break; 
                   case SWITCHTILE+1: 
                        tilemap[checkx][checky]--; 
                        break; 
               } 

               switch(MAPSPOT(checkx,checky,1))  // activate/deactivate item 
               { 
                   case 352: 
                        fwall1 ^=1;  // east switch 
                        break; 
                   case 353: 
                        fwall2 ^= 1; // north switch 
                        break; 
                   case 354: 
                        fwall3 ^= 1; // west switch 
                        break; 
                   case 355: 
                        fwall4 ^= 1; // south switch 
                        break; 

               } 
               SD_PlaySound (LEVELDONESND); 
            }
#else 
	if(!buttonheld[bt_use]&&doornum==2)
        {
	    paper++;

	     if(paper == 1) GetMessage("Some of the documents found..."); 
	else if(paper == 2) GetMessage("Documents found 2/6"); 
	else if(paper == 3) GetMessage("Documents found 3/6"); 
	else if(paper == 4) GetMessage("Documents found 4/6"); 
	else if(paper == 5) GetMessage("Documents found 5/6"); 
	else if(paper == 6) GetMessage("The nuclear weapons were hoax...\nFind your way out.");

            buttonheld[bt_use] = true;
            tilemap[checkx][checky]++;
        }
#endif
	else if (!buttonheld[bt_use] && doornum & 0x80)
	{
		buttonheld[bt_use] = true;
		OperateDoor (doornum & ~0x80);
	}
	#ifndef NEWSOD
	else
		SD_PlaySound (DONOTHINGSND);
	#endif
}

/*
=============================================================================

						   PLAYER CONTROL

=============================================================================
*/



/*
=============
=
= SpawnPlayer
=
=============
*/

void SpawnPlayer (int tilex, int tiley, int dir)
{
	player->obclass = playerobj;
	player->active = true;
	player->tilex = tilex;
	player->tiley = tiley;
	player->areanumber =
		*(mapsegs[0] + farmapylookup[player->tiley]+player->tilex);
	player->x = ((long)tilex<<TILESHIFT)+TILEGLOBAL/2;
	player->y = ((long)tiley<<TILESHIFT)+TILEGLOBAL/2;
	player->state = &s_player;
	player->angle = (1-dir)*90;
	if (player->angle<0)
		player->angle += ANGLES;
	player->flags = FL_NEVERMARK;
	Thrust (0,0);				// set some variables

	InitAreas ();
}


//===========================================================================

/*
=======================
=
= T_KnifeAttack

=
= Update player hands,
= and try to do damage
= when the proper frame
= is reached
=
=======================
*/

void	KnifeAttack (objtype *ob)
{
	objtype *check,*closest;
	long	dist;
	int     damage;

	SD_PlaySound (ATKKNIFESND);
// actually fire
	dist = 0x7fffffff;
	closest = NULL;
	for (check=ob->next ; check ; check=check->next)
		if ( (check->flags & FL_SHOOTABLE)
		&& (check->flags & FL_VISABLE)
		&& abs (check->viewx-centerx) < shootdelta
		)
		{
			if (check->transx < dist)
			{
				dist = check->transx;
				closest = check;
			}
		}

	if (!closest || dist> 0x18000l)
	{
	// missed

		return;
	}

// hit something
	switch(gamestate.weapon)
	{
	 case wp_knife:
	      if (berserk)
		  DamageActor (closest,1000);
	      else
		  DamageActor (closest,US_RndT() >> 4);
	 break;
	 case wp_axe:
	      if (stock)
		  DamageActor (closest,500);
	      else
		  DamageActor (closest,US_RndT() >> 6);
	 break;
	 case wp_lance:
		  DamageActor (closest,2000);
	 break;
	}
}
void	GunAttack (objtype *ob)
{
	objtype *check,*closest,*oldclosest;
	int		damage;
	int		dx,dy,dist;
	long	viewdist;

	switch (gamestate.weapon)
	{
	case wp_pistol:
		SD_PlaySound (ATKPISTOLSND);
		madenoise = true;
		break;
	case wp_machinegun:
		SD_PlaySound (ATKMACHINEGUNSND);
		madenoise = true;
		break;
	case wp_chaingun:
		SD_PlaySound (ATKGATLINGSND);
		madenoise = true;
		break;
	case wp_stengun:
		SD_PlaySound (SILENTSND);
		madenoise = true;
		break;
	}

//	madenoise = true;

//
// find potential targets
//
	viewdist = 0x7fffffffl;
	closest = NULL;

	while (1)
	{
		oldclosest = closest;

		for (check=ob->next ; check ; check=check->next)
			if ( (check->flags & FL_SHOOTABLE)
			&& (check->flags & FL_VISABLE)
			&& abs (check->viewx-centerx) < shootdelta
			)
			{
				if (check->transx < viewdist)
				{
					viewdist = check->transx;
					closest = check;
				}
			}

		if (closest == oldclosest)
			return;						// no more targets, all missed

	//
	// trace a line from player to enemey
	//
		if (CheckLine(closest))
			break;

	}

//
// hit something
//
	dx = abs(closest->tilex - player->tilex);
	dy = abs(closest->tiley - player->tiley);
	dist = dx>dy ? dx:dy;

	if (dist<2)
		damage = US_RndT() / 4;
	else if (dist<4)
		damage = US_RndT() / 6;
	else
	{
		if ( (US_RndT() / 12) < dist)		// missed
			return;
		damage = US_RndT() / 6;
	}
	switch(gamestate.weapon)
	{
	    case wp_pistol:
	    damage = damage*1.00;
	    break;

	    case wp_machinegun:
	    damage = damage*1.50;
	    break;

	    case wp_chaingun:
	    damage = damage*2.00;
	    break;

	    case wp_stengun:
	    damage = damage*2.50;
	    break;
	}
	DamageActor (closest,damage);
}

//===========================================================================

/*
=============
=
= VictorySpin
=
=============
*/

void VictorySpin (void)
{
	long	desty;

	if (player->angle > 270)
	{
		player->angle -= tics * 3;
		if (player->angle < 270)
			player->angle = 270;
	}
	else if (player->angle < 270)
	{
		player->angle += tics * 3;
		if (player->angle > 270)
			player->angle = 270;
	}

	desty = (((long)player->tiley-5)<<TILESHIFT)-0x3000;

	if (player->y > desty)
	{
		player->y -= tics*4096;
		if (player->y < desty)
			player->y = desty;
	}
}


//===========================================================================

/*
==========
=
= T_Attack
=
==========
*/

void	T_Attack (objtype *ob)
{
	struct	atkinf	*cur; 
        int i;

	UpdateFace ();

	if (gamestate.victoryflag)		// watching the BJ actor
	{
		VictorySpin ();
		return;
	}

	if ( buttonstate[bt_use] && !buttonheld[bt_use] )
		buttonstate[bt_use] = false;

	if ( buttonstate[bt_attack] && !buttonheld[bt_attack])
		buttonstate[bt_attack] = false;

	ControlMovement (ob);
	if (gamestate.victoryflag)		// watching the BJ actor
		return;

	plux = player->x >> UNSIGNEDSHIFT;			// scale to fit in unsigned
	pluy = player->y >> UNSIGNEDSHIFT;
	player->tilex = player->x >> TILESHIFT;		// scale to tile values
	player->tiley = player->y >> TILESHIFT;

//
// change frame and fire
//
	gamestate.attackcount -= tics;
	while (gamestate.attackcount <= 0)
	{
		cur = &attackinfo[gamestate.weapon][gamestate.attackframe];
		switch (cur->attack)
		{

 

		case -1:
			ob->state = &s_player;
			if (!gamestate.ammo  && gamestate.weapon < wp_chaingun
			    || !gamestate.extraammo1 && gamestate.weapon >= wp_chaingun)
			{

				StatusDrawPic (17,4,BJMADPIC);facecount = 0;gotgatgun=1;
				gamestate.weapon = wp_knife;
				gamestate.chosenweapon = wp_knife;
			}
			else
			{
				if (gamestate.weapon != gamestate.chosenweapon)
				{
					gamestate.weapon = gamestate.chosenweapon;
				}
			};
			gamestate.attackframe = gamestate.weaponframe = 0;
			return;

		// End of firing sequence - check ammo and fall back to best possible weapon with ammo
		case 4:
			if (gamestate.extraammo1 && buttonstate[bt_attack])
				gamestate.attackframe -= 2;
			break;
		case 5:
			if (!gamestate.extraammo1)
				break;
			if (buttonstate[bt_attack])
				gamestate.attackframe -= 2;

		case 1:
			if (!gamestate.ammo && gamestate.weapon <= wp_machinegun
			   || !gamestate.extraammo1 && gamestate.weapon >= wp_chaingun)
			{
				gamestate.attackframe++;
				break;
			}

			// Recoil effect and weapon control
			GunAttack (ob);
			switch(gamestate.weapon)
			{
			    case wp_pistol:
			      gamestate.ammo--;
			      DrawAmmo ();
			      Thrust(player->angle,-0x200 - (gamestate.chosenweapon*50));
			    break;

			    case wp_machinegun:
			      gamestate.ammo--;
			      DrawAmmo ();
			      Thrust(player->angle,-0x400 - (gamestate.chosenweapon*50));
			    break;

			    case wp_chaingun:
			      gamestate.extraammo1--;
			      DrawExtraAmmo1 ();
			      Thrust(player->angle,-0x800 - (gamestate.chosenweapon*50));
			    break;

			    case wp_stengun:
			      gamestate.extraammo1--;
			      DrawExtraAmmo1 ();
			      Thrust(player->angle,-0x1000 - (gamestate.chosenweapon*50));
			    break;
			}

			// If shot while in disquise
			if(gamestate.uniform)
			    gamestate.uniform=0;
			break;

		case 2:
			KnifeAttack (ob);
			break;

		case 3:
			if (gamestate.ammo && buttonstate[bt_attack])
				gamestate.attackframe -= 2;
			break;
		}

		gamestate.attackcount += cur->tics;
		gamestate.attackframe++;
		gamestate.weaponframe =
			attackinfo[gamestate.weapon][gamestate.attackframe].frame;
	}

}



//===========================================================================

/*
==========
=
= T_Player
=
==========
*/

void	T_Player (objtype *ob)
{
	if (gamestate.victoryflag)		// watching the BJ actor
	{
		VictorySpin ();
		return;
	}
	UpdateFace ();
	CheckWeaponChange ();

	if ( buttonstate[bt_use] )
		Cmd_Use ();

	if ( buttonstate[bt_attack] && !buttonheld[bt_attack])
		Cmd_Fire ();

	ControlMovement (ob);
	if (gamestate.victoryflag)		// watching the BJ actor
		return;


	plux = player->x >> UNSIGNEDSHIFT;			// scale to fit in unsigned
	pluy = player->y >> UNSIGNEDSHIFT;
	player->tilex = player->x >> TILESHIFT;		// scale to tile values
	player->tiley = player->y >> TILESHIFT;
}

//
// Teleporter by MCS
//

void WarpPlayer (int facedir)
{
     objtype *check;
     int x,y;

     buttonstate[bt_attack] = false;
     buttonheld[bt_attack] = false;
     gamestate.attackframe = 0;
     gamestate.weaponframe = 0;
     DrawPlayerWeapon ();
     ThreeDRefresh();
     switch (facedir)
     {
     case EAST:
	  check = actorat[warpex][warpey];
	  if (check > objlist && (check->flags & FL_SHOOTABLE))
	      KillActor(check);
	  SpawnPlayer(warpex,warpey,facedir);
	  break;
     case WEST:
	  check = actorat[warpwx][warpwy];
	  if (check > objlist && (check->flags & FL_SHOOTABLE))
	      KillActor(check);
	  SpawnPlayer(warpwx,warpwy,facedir);
	  break;
     }

     SD_PlaySound(BOSSACTIVESND);
     if (DigiMode != sds_Off)
     {
	 long lasttimecount = TimeCount;
	 while(TimeCount < lasttimecount+35)
	       SD_Poll();
     }
     else
	 VW_WaitVBL(1*50);

     buttonstate[bt_attack] = false;
     buttonheld[bt_attack] = false;
     gamestate.attackframe = 0;
     gamestate.weaponframe = 0;
     DrawPlayerWeapon ();
     ThreeDRefresh();
}
